/* $Id: config.c 1 2023-02-24 13:31:37Z nishi $ */
#include <nikkel/config.h>

#include <nikkel.h>
#include <nikkel/util.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void nfree(void* ptr){
	if(ptr != NULL) free(ptr);
}

struct nikkel_config* nikkel_config_parse(const char* path){
	struct nikkel_config* result = malloc(sizeof(*result));
	result->c_contact = NULL;
	result->c_wikipath = NULL;
	result->c_csspath = NULL;
	result->c_icon = NULL;
	result->c_image = NULL;
	result->c_name = sstrdup("Untitled Wiki");
	result->c_prefix = sstrdup("/");
	result->c_status = NIKKEL_SUCCESS;
	result->c_name = sstrdup("Untitled Wiki");
	result->c_prefix = sstrdup("/");
	result->c_status = NIKKEL_SUCCESS;
	FILE* config = fopen(path, "r");
	if(config == NULL){
		result->c_status = NIKKEL_CONFIG_NOTF;
	}else{
		char* buffer = malloc(1);
		buffer[0] = 0;
		int counter = 0;
		char ch;
		while(1){
			fread(&ch, 1, 1, config);
			if(feof(config) || ch == '\n'){
				if(counter != 0){
					int i;
					char equal = 0;
					for(i = 0; buffer[i] != 0; i++){
						if(buffer[i] == '='){
							equal = 1;
							break;
						}else if(buffer[i] == '#'){
							break;
						}
					}
					if(equal){
						char* key = buffer;
						key[i] = 0;
						char* value = buffer + i + 1;
						if(strcmp(key, "Contact") == 0){
							if(result->c_contact != NULL) free(result->c_contact);
							result->c_contact = sstrdup(value);
						}else if(strcmp(key, "Path") == 0){
							if(result->c_wikipath != NULL) free(result->c_wikipath);
							result->c_wikipath = sstrdup(value);
						}else if(strcmp(key, "CSSPath") == 0){
							if(result->c_csspath != NULL) free(result->c_csspath);
							result->c_csspath = sstrdup(value);
						}else if(strcmp(key, "Name") == 0){
							if(result->c_name != NULL) free(result->c_name);
							result->c_name = sstrdup(value);
						}else if(strcmp(key, "Prefix") == 0){
							if(result->c_prefix != NULL) free(result->c_prefix);
							result->c_prefix = sstrdup(value);
						}else if(strcmp(key, "Icon") == 0){
							if(result->c_icon != NULL) free(result->c_icon);
							result->c_icon = sstrdup(value);
						}else if(strcmp(key, "Image") == 0){
							if(result->c_image != NULL) free(result->c_image);
							result->c_image = sstrdup(value);
						}
					}
				}
				free(buffer);
				buffer = malloc(1);
				buffer[0] = 0;
				counter = 0;
				if(feof(config)) break;
			}else{
				buffer = realloc(buffer, counter + 2);
				buffer[counter] = ch;
				buffer[counter + 1] = 0;
				counter++;
			}
		}
		free(buffer);
		fclose(config);
	}
	if(result->c_wikipath == NULL){
		result->c_status = NIKKEL_CONFIG_PATH_UNSET;
	}
	if(result->c_csspath == NULL){
		result->c_status = NIKKEL_CONFIG_CSSPATH_UNSET;
	}
	return result;
}

void nikkel_config_free(struct nikkel_config* config){
	nfree(config->c_contact);
	nfree(config->c_wikipath);
	nfree(config->c_name);
	nfree(config->c_csspath);
	nfree(config->c_icon);
	nfree(config->c_image);
	free(config);
}
